# coding: utf-8

"""
    EF Portal REST API

    # Introduction to EF Portal REST API  Welcome to the documentation for the EF Portal REST API, which provides powerful endpoints to manage `GRID`, `MONITOR`, and `SYSTEM` operations.  This comprehensive guide will help you navigate and utilize our API effectively. ## Access Methods  You can interact with the EF Portal through two primary methods:  1. **Web UI**: <a href=\"swagger.html\" target=\"_blank\">Swagger UI</a> to submit commands. **ReDoc** is for documentation purposes.  1. **Command Line Interface**: A Python-based client for programmatic access. - <a href=\"https://pypi.org/project/efpclient/\" target=\"_blank\">EF Portal Client</a> hosted on `PyPi.org`.  Both the Web UI and Python client support all API endpoints described in this documentation. ## API Structure  Our API is organized into three distinct categories for easy navigation and use:  1. **Grid**: Manage hosts, queues, jobs, and clusters. 1. **Monitor**: Access user information and manage licenses (admin-only operations). 1. **System**: Handle services, spoolers, and file operations.  ## Key Operations  ### Grid Operations  - Host and queue management - Job control (find, list, delete, resume, suspend) - Cluster information  ### Monitor Operations (**_Admin Only_**)  - User session management - License control and usage monitoring  ### System Operations  - Service management (list, describe, submit) - Spooler control (list, delete) - File handling (list, upload)  ## OpenAPI Version  You can find the version of OpenAPI spec from the `version` object  ```yaml openapi: 3.0.1   info:   version: '1.0'   title: EF Portal REST API   ...   ```  ## Authentication    The EF Portal REST API uses **token-based** authentication:  - **EF Token**: Your personal access token for API authentication.  ## Getting Started To begin using the API, ensure you have your EF Token ready. Refer to the specific endpoint documentation for detailed usage instructions and examples.   # noqa: E501

    OpenAPI spec version: 1.0
    Contact: info@ni-sp-software.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class Host(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'manager': 'str',
        'architecture': 'str',
        'family': 'str',
        'cpus': 'int',
        'slots': 'int',
        'running_jobs': 'int',
        'resources': 'list[GridResource]',
        'status': 'GridStatus'
    }

    attribute_map = {
        'name': 'name',
        'manager': 'manager',
        'architecture': 'architecture',
        'family': 'family',
        'cpus': 'cpus',
        'slots': 'slots',
        'running_jobs': 'runningJobs',
        'resources': 'resources',
        'status': 'status'
    }

    def __init__(self, name=None, manager=None, architecture=None, family=None, cpus=None, slots=None, running_jobs=None, resources=None, status=None):  # noqa: E501
        """Host - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._manager = None
        self._architecture = None
        self._family = None
        self._cpus = None
        self._slots = None
        self._running_jobs = None
        self._resources = None
        self._status = None
        self.discriminator = None
        if name is not None:
            self.name = name
        if manager is not None:
            self.manager = manager
        if architecture is not None:
            self.architecture = architecture
        if family is not None:
            self.family = family
        if cpus is not None:
            self.cpus = cpus
        if slots is not None:
            self.slots = slots
        if running_jobs is not None:
            self.running_jobs = running_jobs
        if resources is not None:
            self.resources = resources
        if status is not None:
            self.status = status

    @property
    def name(self):
        """Gets the name of this Host.  # noqa: E501


        :return: The name of this Host.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Host.


        :param name: The name of this Host.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def manager(self):
        """Gets the manager of this Host.  # noqa: E501


        :return: The manager of this Host.  # noqa: E501
        :rtype: str
        """
        return self._manager

    @manager.setter
    def manager(self, manager):
        """Sets the manager of this Host.


        :param manager: The manager of this Host.  # noqa: E501
        :type: str
        """

        self._manager = manager

    @property
    def architecture(self):
        """Gets the architecture of this Host.  # noqa: E501


        :return: The architecture of this Host.  # noqa: E501
        :rtype: str
        """
        return self._architecture

    @architecture.setter
    def architecture(self, architecture):
        """Sets the architecture of this Host.


        :param architecture: The architecture of this Host.  # noqa: E501
        :type: str
        """

        self._architecture = architecture

    @property
    def family(self):
        """Gets the family of this Host.  # noqa: E501


        :return: The family of this Host.  # noqa: E501
        :rtype: str
        """
        return self._family

    @family.setter
    def family(self, family):
        """Sets the family of this Host.


        :param family: The family of this Host.  # noqa: E501
        :type: str
        """

        self._family = family

    @property
    def cpus(self):
        """Gets the cpus of this Host.  # noqa: E501


        :return: The cpus of this Host.  # noqa: E501
        :rtype: int
        """
        return self._cpus

    @cpus.setter
    def cpus(self, cpus):
        """Sets the cpus of this Host.


        :param cpus: The cpus of this Host.  # noqa: E501
        :type: int
        """

        self._cpus = cpus

    @property
    def slots(self):
        """Gets the slots of this Host.  # noqa: E501


        :return: The slots of this Host.  # noqa: E501
        :rtype: int
        """
        return self._slots

    @slots.setter
    def slots(self, slots):
        """Sets the slots of this Host.


        :param slots: The slots of this Host.  # noqa: E501
        :type: int
        """

        self._slots = slots

    @property
    def running_jobs(self):
        """Gets the running_jobs of this Host.  # noqa: E501


        :return: The running_jobs of this Host.  # noqa: E501
        :rtype: int
        """
        return self._running_jobs

    @running_jobs.setter
    def running_jobs(self, running_jobs):
        """Sets the running_jobs of this Host.


        :param running_jobs: The running_jobs of this Host.  # noqa: E501
        :type: int
        """

        self._running_jobs = running_jobs

    @property
    def resources(self):
        """Gets the resources of this Host.  # noqa: E501


        :return: The resources of this Host.  # noqa: E501
        :rtype: list[GridResource]
        """
        return self._resources

    @resources.setter
    def resources(self, resources):
        """Sets the resources of this Host.


        :param resources: The resources of this Host.  # noqa: E501
        :type: list[GridResource]
        """

        self._resources = resources

    @property
    def status(self):
        """Gets the status of this Host.  # noqa: E501


        :return: The status of this Host.  # noqa: E501
        :rtype: GridStatus
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this Host.


        :param status: The status of this Host.  # noqa: E501
        :type: GridStatus
        """

        self._status = status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Host, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Host):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
