# coding: utf-8

"""
    EF Portal REST API

    # Introduction to EF Portal REST API  Welcome to the documentation for the EF Portal REST API, which provides powerful endpoints to manage `GRID`, `MONITOR`, and `SYSTEM` operations.  This comprehensive guide will help you navigate and utilize our API effectively. ## Access Methods  You can interact with the EF Portal through two primary methods:  1. **Web UI**: <a href=\"swagger.html\" target=\"_blank\">Swagger UI</a> to submit commands. **ReDoc** is for documentation purposes.  1. **Command Line Interface**: A Python-based client for programmatic access. - <a href=\"https://pypi.org/project/efpclient/\" target=\"_blank\">EF Portal Client</a> hosted on `PyPi.org`.  Both the Web UI and Python client support all API endpoints described in this documentation. ## API Structure  Our API is organized into three distinct categories for easy navigation and use:  1. **Grid**: Manage hosts, queues, jobs, and clusters. 1. **Monitor**: Access user information and manage licenses (admin-only operations). 1. **System**: Handle services, spoolers, and file operations.  ## Key Operations  ### Grid Operations  - Host and queue management - Job control (find, list, delete, resume, suspend) - Cluster information  ### Monitor Operations (**_Admin Only_**)  - User session management - License control and usage monitoring  ### System Operations  - Service management (list, describe, submit) - Spooler control (list, delete) - File handling (list, upload)  ## OpenAPI Version  You can find the version of OpenAPI spec from the `version` object  ```yaml openapi: 3.0.1   info:   version: '1.0'   title: EF Portal REST API   ...   ```  ## Authentication    The EF Portal REST API uses **token-based** authentication:  - **EF Token**: Your personal access token for API authentication.  ## Getting Started To begin using the API, ensure you have your EF Token ready. Refer to the specific endpoint documentation for detailed usage instructions and examples.   # noqa: E501

    OpenAPI spec version: 1.0
    Contact: info@ni-sp-software.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class Item(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'path': 'str',
        'vroot': 'str',
        'name': 'str',
        'type': 'str',
        'modified': 'str',
        'url': 'str',
        'size': 'Size'
    }

    attribute_map = {
        'path': 'path',
        'vroot': 'vroot',
        'name': 'name',
        'type': 'type',
        'modified': 'modified',
        'url': 'url',
        'size': 'size'
    }

    def __init__(self, path=None, vroot=None, name=None, type=None, modified=None, url=None, size=None):  # noqa: E501
        """Item - a model defined in Swagger"""  # noqa: E501
        self._path = None
        self._vroot = None
        self._name = None
        self._type = None
        self._modified = None
        self._url = None
        self._size = None
        self.discriminator = None
        if path is not None:
            self.path = path
        if vroot is not None:
            self.vroot = vroot
        if name is not None:
            self.name = name
        if type is not None:
            self.type = type
        if modified is not None:
            self.modified = modified
        if url is not None:
            self.url = url
        if size is not None:
            self.size = size

    @property
    def path(self):
        """Gets the path of this Item.  # noqa: E501


        :return: The path of this Item.  # noqa: E501
        :rtype: str
        """
        return self._path

    @path.setter
    def path(self, path):
        """Sets the path of this Item.


        :param path: The path of this Item.  # noqa: E501
        :type: str
        """

        self._path = path

    @property
    def vroot(self):
        """Gets the vroot of this Item.  # noqa: E501


        :return: The vroot of this Item.  # noqa: E501
        :rtype: str
        """
        return self._vroot

    @vroot.setter
    def vroot(self, vroot):
        """Sets the vroot of this Item.


        :param vroot: The vroot of this Item.  # noqa: E501
        :type: str
        """

        self._vroot = vroot

    @property
    def name(self):
        """Gets the name of this Item.  # noqa: E501


        :return: The name of this Item.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Item.


        :param name: The name of this Item.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def type(self):
        """Gets the type of this Item.  # noqa: E501


        :return: The type of this Item.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this Item.


        :param type: The type of this Item.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def modified(self):
        """Gets the modified of this Item.  # noqa: E501


        :return: The modified of this Item.  # noqa: E501
        :rtype: str
        """
        return self._modified

    @modified.setter
    def modified(self, modified):
        """Sets the modified of this Item.


        :param modified: The modified of this Item.  # noqa: E501
        :type: str
        """

        self._modified = modified

    @property
    def url(self):
        """Gets the url of this Item.  # noqa: E501


        :return: The url of this Item.  # noqa: E501
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this Item.


        :param url: The url of this Item.  # noqa: E501
        :type: str
        """

        self._url = url

    @property
    def size(self):
        """Gets the size of this Item.  # noqa: E501


        :return: The size of this Item.  # noqa: E501
        :rtype: Size
        """
        return self._size

    @size.setter
    def size(self, size):
        """Sets the size of this Item.


        :param size: The size of this Item.  # noqa: E501
        :type: Size
        """

        self._size = size

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Item, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Item):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
