# coding: utf-8

"""
    EF Portal REST API

    # Introduction to EF Portal REST API  Welcome to the documentation for the EF Portal REST API, which provides powerful endpoints to manage `GRID`, `MONITOR`, and `SYSTEM` operations.  This comprehensive guide will help you navigate and utilize our API effectively. ## Access Methods  You can interact with the EF Portal through two primary methods:  1. **Web UI**: <a href=\"swagger.html\" target=\"_blank\">Swagger UI</a> to submit commands. **ReDoc** is for documentation purposes.  1. **Command Line Interface**: A Python-based client for programmatic access. - <a href=\"https://pypi.org/project/efpclient/\" target=\"_blank\">EF Portal Client</a> hosted on `PyPi.org`.  Both the Web UI and Python client support all API endpoints described in this documentation. ## API Structure  Our API is organized into three distinct categories for easy navigation and use:  1. **Grid**: Manage hosts, queues, jobs, and clusters. 1. **Monitor**: Access user information and manage licenses (admin-only operations). 1. **System**: Handle services, spoolers, and file operations.  ## Key Operations  ### Grid Operations  - Host and queue management - Job control (find, list, delete, resume, suspend) - Cluster information  ### Monitor Operations (**_Admin Only_**)  - User session management - License control and usage monitoring  ### System Operations  - Service management (list, describe, submit) - Spooler control (list, delete) - File handling (list, upload)  ## OpenAPI Version  You can find the version of OpenAPI spec from the `version` object  ```yaml openapi: 3.0.1   info:   version: '1.0'   title: EF Portal REST API   ...   ```  ## Authentication    The EF Portal REST API uses **token-based** authentication:  - **EF Token**: Your personal access token for API authentication.  ## Getting Started To begin using the API, ensure you have your EF Token ready. Refer to the specific endpoint documentation for detailed usage instructions and examples.   # noqa: E501

    OpenAPI spec version: 1.0
    Contact: info@ni-sp-software.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ServiceRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'sdf': 'str',
        'uri': 'str',
        'action': 'str',
        'spooler_uri': 'str',
        'options': 'list[ServiceParam]'
    }

    attribute_map = {
        'sdf': 'sdf',
        'uri': 'uri',
        'action': 'action',
        'spooler_uri': 'spoolerUri',
        'options': 'options'
    }

    def __init__(self, sdf=None, uri=None, action=None, spooler_uri=None, options=None):  # noqa: E501
        """ServiceRequest - a model defined in Swagger"""  # noqa: E501
        self._sdf = None
        self._uri = None
        self._action = None
        self._spooler_uri = None
        self._options = None
        self.discriminator = None
        if sdf is not None:
            self.sdf = sdf
        if uri is not None:
            self.uri = uri
        if action is not None:
            self.action = action
        if spooler_uri is not None:
            self.spooler_uri = spooler_uri
        if options is not None:
            self.options = options

    @property
    def sdf(self):
        """Gets the sdf of this ServiceRequest.  # noqa: E501


        :return: The sdf of this ServiceRequest.  # noqa: E501
        :rtype: str
        """
        return self._sdf

    @sdf.setter
    def sdf(self, sdf):
        """Sets the sdf of this ServiceRequest.


        :param sdf: The sdf of this ServiceRequest.  # noqa: E501
        :type: str
        """

        self._sdf = sdf

    @property
    def uri(self):
        """Gets the uri of this ServiceRequest.  # noqa: E501


        :return: The uri of this ServiceRequest.  # noqa: E501
        :rtype: str
        """
        return self._uri

    @uri.setter
    def uri(self, uri):
        """Sets the uri of this ServiceRequest.


        :param uri: The uri of this ServiceRequest.  # noqa: E501
        :type: str
        """

        self._uri = uri

    @property
    def action(self):
        """Gets the action of this ServiceRequest.  # noqa: E501


        :return: The action of this ServiceRequest.  # noqa: E501
        :rtype: str
        """
        return self._action

    @action.setter
    def action(self, action):
        """Sets the action of this ServiceRequest.


        :param action: The action of this ServiceRequest.  # noqa: E501
        :type: str
        """

        self._action = action

    @property
    def spooler_uri(self):
        """Gets the spooler_uri of this ServiceRequest.  # noqa: E501


        :return: The spooler_uri of this ServiceRequest.  # noqa: E501
        :rtype: str
        """
        return self._spooler_uri

    @spooler_uri.setter
    def spooler_uri(self, spooler_uri):
        """Sets the spooler_uri of this ServiceRequest.


        :param spooler_uri: The spooler_uri of this ServiceRequest.  # noqa: E501
        :type: str
        """

        self._spooler_uri = spooler_uri

    @property
    def options(self):
        """Gets the options of this ServiceRequest.  # noqa: E501


        :return: The options of this ServiceRequest.  # noqa: E501
        :rtype: list[ServiceParam]
        """
        return self._options

    @options.setter
    def options(self, options):
        """Sets the options of this ServiceRequest.


        :param options: The options of this ServiceRequest.  # noqa: E501
        :type: list[ServiceParam]
        """

        self._options = options

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ServiceRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ServiceRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
