# coding: utf-8

"""
    EF Portal REST API

    # Introduction to EF Portal REST API  Welcome to the documentation for the EF Portal REST API, which provides powerful endpoints to manage `GRID`, `MONITOR`, and `SYSTEM` operations.  This comprehensive guide will help you navigate and utilize our API effectively. ## Access Methods  You can interact with the EF Portal through two primary methods:  1. **Web UI**: <a href=\"swagger.html\" target=\"_blank\">Swagger UI</a> to submit commands. **ReDoc** is for documentation purposes.  1. **Command Line Interface**: A Python-based client for programmatic access. - <a href=\"https://pypi.org/project/efpclient/\" target=\"_blank\">EF Portal Client</a> hosted on `PyPi.org`.  Both the Web UI and Python client support all API endpoints described in this documentation. ## API Structure  Our API is organized into three distinct categories for easy navigation and use:  1. **Grid**: Manage hosts, queues, jobs, and clusters. 1. **Monitor**: Access user information and manage licenses (admin-only operations). 1. **System**: Handle services, spoolers, and file operations.  ## Key Operations  ### Grid Operations  - Host and queue management - Job control (find, list, delete, resume, suspend) - Cluster information  ### Monitor Operations (**_Admin Only_**)  - User session management - License control and usage monitoring  ### System Operations  - Service management (list, describe, submit) - Spooler control (list, delete) - File handling (list, upload)  ## OpenAPI Version  You can find the version of OpenAPI spec from the `version` object  ```yaml openapi: 3.0.1   info:   version: '1.0'   title: EF Portal REST API   ...   ```  ## Authentication    The EF Portal REST API uses **token-based** authentication:  - **EF Token**: Your personal access token for API authentication.  ## Getting Started To begin using the API, ensure you have your EF Token ready. Refer to the specific endpoint documentation for detailed usage instructions and examples.   # noqa: E501

    OpenAPI spec version: 1.0
    Contact: info@ni-sp-software.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class Spooler(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'uri': 'str',
        'name': 'str',
        'project': 'str',
        'creation_time': 'str',
        'last_modified': 'str',
        'expiration_time': 'str',
        'items': 'int',
        'status': 'str'
    }

    attribute_map = {
        'uri': 'uri',
        'name': 'name',
        'project': 'project',
        'creation_time': 'creation-time',
        'last_modified': 'last-modified',
        'expiration_time': 'expiration-time',
        'items': 'items',
        'status': 'status'
    }

    def __init__(self, uri=None, name=None, project=None, creation_time=None, last_modified=None, expiration_time=None, items=None, status=None):  # noqa: E501
        """Spooler - a model defined in Swagger"""  # noqa: E501
        self._uri = None
        self._name = None
        self._project = None
        self._creation_time = None
        self._last_modified = None
        self._expiration_time = None
        self._items = None
        self._status = None
        self.discriminator = None
        if uri is not None:
            self.uri = uri
        if name is not None:
            self.name = name
        if project is not None:
            self.project = project
        if creation_time is not None:
            self.creation_time = creation_time
        if last_modified is not None:
            self.last_modified = last_modified
        if expiration_time is not None:
            self.expiration_time = expiration_time
        if items is not None:
            self.items = items
        if status is not None:
            self.status = status

    @property
    def uri(self):
        """Gets the uri of this Spooler.  # noqa: E501


        :return: The uri of this Spooler.  # noqa: E501
        :rtype: str
        """
        return self._uri

    @uri.setter
    def uri(self, uri):
        """Sets the uri of this Spooler.


        :param uri: The uri of this Spooler.  # noqa: E501
        :type: str
        """

        self._uri = uri

    @property
    def name(self):
        """Gets the name of this Spooler.  # noqa: E501


        :return: The name of this Spooler.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Spooler.


        :param name: The name of this Spooler.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def project(self):
        """Gets the project of this Spooler.  # noqa: E501


        :return: The project of this Spooler.  # noqa: E501
        :rtype: str
        """
        return self._project

    @project.setter
    def project(self, project):
        """Sets the project of this Spooler.


        :param project: The project of this Spooler.  # noqa: E501
        :type: str
        """

        self._project = project

    @property
    def creation_time(self):
        """Gets the creation_time of this Spooler.  # noqa: E501


        :return: The creation_time of this Spooler.  # noqa: E501
        :rtype: str
        """
        return self._creation_time

    @creation_time.setter
    def creation_time(self, creation_time):
        """Sets the creation_time of this Spooler.


        :param creation_time: The creation_time of this Spooler.  # noqa: E501
        :type: str
        """

        self._creation_time = creation_time

    @property
    def last_modified(self):
        """Gets the last_modified of this Spooler.  # noqa: E501


        :return: The last_modified of this Spooler.  # noqa: E501
        :rtype: str
        """
        return self._last_modified

    @last_modified.setter
    def last_modified(self, last_modified):
        """Sets the last_modified of this Spooler.


        :param last_modified: The last_modified of this Spooler.  # noqa: E501
        :type: str
        """

        self._last_modified = last_modified

    @property
    def expiration_time(self):
        """Gets the expiration_time of this Spooler.  # noqa: E501


        :return: The expiration_time of this Spooler.  # noqa: E501
        :rtype: str
        """
        return self._expiration_time

    @expiration_time.setter
    def expiration_time(self, expiration_time):
        """Sets the expiration_time of this Spooler.


        :param expiration_time: The expiration_time of this Spooler.  # noqa: E501
        :type: str
        """

        self._expiration_time = expiration_time

    @property
    def items(self):
        """Gets the items of this Spooler.  # noqa: E501


        :return: The items of this Spooler.  # noqa: E501
        :rtype: int
        """
        return self._items

    @items.setter
    def items(self, items):
        """Sets the items of this Spooler.


        :param items: The items of this Spooler.  # noqa: E501
        :type: int
        """

        self._items = items

    @property
    def status(self):
        """Gets the status of this Spooler.  # noqa: E501


        :return: The status of this Spooler.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this Spooler.


        :param status: The status of this Spooler.  # noqa: E501
        :type: str
        """

        self._status = status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Spooler, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Spooler):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
